import { BlendFunction, DepthOfFieldEffect } from 'postprocessing';

export interface DepthOfFieldProps {
    /**
     * The blend function of this effect. This prop is not reactive.
     */
    blendFunction?: BlendFunction;
    /**
     * The focus distance in world units.
     */
    worldFocusDistance?: number;
    /**
     * The focus range in world units.
     */
    worldFocusRange?: number;
    /**
     * The normalized focus distance. Range is [0.0, 1.0].
     */
    focusDistance?: number;
    /**
     * The focus range. Range is [0.0, 1.0].
     */
    focusRange?: number;
    /**
     * The scale of the bokeh blur.
     */
    bokehScale?: number;
    resolutionScale?: number;
    resolutionX?: number;
    resolutionY?: number;
}
declare const _default: import('vue').DefineComponent<__VLS_TypePropsToOption<DepthOfFieldProps>, {
    pass: import('vue').ShallowRef<import('postprocessing').EffectPass | null>;
    effect: import('vue').ShallowRef<DepthOfFieldEffect | null>;
}, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<__VLS_TypePropsToOption<DepthOfFieldProps>>>, {}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
